// GpsMonitor
// code by jph

import java.lang.Math;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

class SpaceVehicle
{
  long   time;
  int    id;  
  double gpsx;
  double gpsy;  
  String label;
  
  SpaceVehicle() {}
  
  SpaceVehicle(long time) {
    this.time=time;
  }
  
  SpaceVehicle(long time,int id,double gpsx,double gpsy,String label) {
    this.time =time;
    this.id   =id;
    this.gpsx =gpsx;
    this.gpsy =gpsy;
    this.label=label;
  }
}

class EarthMonitor
extends Monitor
implements MouseListener,MouseMotionListener
{
  static final int WIDTH =784;
 	static final int HEIGHT=392;

 	boolean isDirty;		
	Image myImage;
	Image[] mySats;
	Hashtable myHashtable;
	Pixel offset;
	
	EarthMonitor() {
  	super("Earth");
  	int c1;
		isDirty=true;
		myImage=getToolkit().getImage("res/earth19.jpg");
		mySats=new Image[2];
		mySats[0]=getToolkit().getImage("res/tiny.upl.jpg");
		mySats[1]=getToolkit().getImage("res/tiny.dnl.jpg");
		myHashtable=new Hashtable();
		offset=new Pixel();		
		redraw=1000;
	}
	
	void add(long time,int id,double gpsx,double gpsy,String label) {
  	myHashtable.put(new Integer(id),new SpaceVehicle(time,id,gpsx,gpsy,label));
	}
	
	public void paintMonitor(Graphics myGraphics) {
  	int c1;
  	myGraphics.setColor(Color.gray);
		myGraphics.fillRect(0,0,getSize().width,getSize().height);
		  	
  	SpaceVehicle mySpaceVehicle;
  	Pixel posit=new Pixel();
    offset.pix=(getSize().width -WIDTH )/2;
    offset.piy=(getSize().height-HEIGHT)/2;
  	MediaTracker myMediaTracker=new MediaTracker(this);
    myMediaTracker.addImage(myImage,0);
    try {
      myMediaTracker.waitForAll();
      myGraphics.drawImage(myImage,offset.pix,offset.piy,this);
    } catch (InterruptedException myInterruptedException) {
    }
    for (c1=0;c1<25;c1++) {
      mySpaceVehicle=(SpaceVehicle)myHashtable.get(new Integer(c1));
      if (mySpaceVehicle!=null)
        if (time<mySpaceVehicle.time) {
          posit.pix=Xpixel(mySpaceVehicle.gpsx);
          posit.piy=Ypixel(mySpaceVehicle.gpsy);
          myGraphics.drawImage(mySats[c1==0?0:1],posit.pix-4,posit.piy-4,this); // image has size 8 x 8
          TinyString(myGraphics,mySpaceVehicle.label,posit.pix+6,posit.piy+3);               
        }
    }
  }  
  
	public int Xpixel(double gpsx) {
		return (int)(offset.pix+WIDTH /2+(gpsx/180)*WIDTH /2);
	}
	
	public int Ypixel(double gpsy) {
		return (int)(offset.piy+HEIGHT/2-(gpsy/90)*HEIGHT/2);		
	}
	
	
  public void mousePressed(MouseEvent myMouseEvent) {
		//click.pix=myMouseEvent.getX();
		//click.piy=myMouseEvent.getY();	  
	}
	public void mouseReleased(MouseEvent myMouseEvent) {
		//if (myMouseEvent.getClickCount()==2) {
		//	myCansat7.myJComboBox[myCansat7.TRACK].setSelectedIndex(0);			
		//	repaint();
		//}
	}
	public void mouseClicked(MouseEvent myMouseEvent) {};
	
	public void mouseDragged(MouseEvent myMouseEvent) {		
		//myCansat7.myJComboBox[myCansat7.TRACK].setSelectedIndex(2);
		//offset.pix+=(int)(myMouseEvent.getX()-click.pix);
		//offset.piy+=(int)(myMouseEvent.getY()-click.piy);		
		//click.pix=myMouseEvent.getX();
		//click.piy=myMouseEvent.getY();				
		//dirtyFoc=false;
		//repaint();
	}
}



