//cansat7 ground station code by jph


//TODO take over some mouse routines (last point etc!)

//EnhancedGraphics implements nice drawing of
// - strings
// - lineStrips
// - circles

import java.lang.Math;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.text.*;
import java.util.*;

//----------------------------------------------------
class Mark {
	int pix,piy;
	int idx;
	boolean label;
	String str;
}

//----------------------------------------------------
class EnhancedGraphics
extends JComponent
{	
	String title,subtitle;		
	boolean isMouseOver=false;
	Mark mouse;
	Mark area;
	
	static final SimpleDateFormat mySimpleDateFormat=new SimpleDateFormat("hh:mm:ss",Locale.getDefault());
	
	EnhancedGraphics(String title_in) {		
		title=title_in;
		subtitle="";
		mouse=new Mark();
		area=new Mark();		
		bColor=new Color(0,0,0);
		bColor=Color.orange;
	}

  void EnhancedString(Graphics myGraphics,String myString,int x,int y) {
		myGraphics.setFont(new Font("verdana",Font.BOLD,11));
		myGraphics.setColor(Color.darkGray);
		myGraphics.drawString(myString,x+1,y+0);
		myGraphics.drawString(myString,x+0,y+1);
		myGraphics.setColor(Color.gray);
		myGraphics.drawString(myString,x-1,y+0);
		myGraphics.drawString(myString,x+0,y-1);		
		myGraphics.setColor(Color.white);
		myGraphics.drawString(myString,x,y);	
	}
  void EnhancedTitle(Graphics myGraphics) {
		EnhancedString(myGraphics,title+" "+subtitle,5,13);
		if (isMouseOver) //debug information
			EnhancedString(myGraphics,""+mouse.pix+" "+mouse.piy,5,22);		
	}
	void EnhancedMark(Graphics myGraphics,int x,int y) {
		myGraphics.setColor(Color.gray);
		myGraphics.fillArc(x-4,y-4,11,11,0,360);
		myGraphics.setColor(Color.white);
		myGraphics.fillArc(x-6,y-6,11,11,0,360);		
		myGraphics.setColor(bColor);
		myGraphics.fillArc(x-5,y-5,11,11,0,360);
	}
	
	double arcAng=0;
	long arcSync=System.currentTimeMillis();
	void EnhancedArcedCircle(Graphics myGraphics,int x,int y) {		
		arcAng+=(double)(System.currentTimeMillis()-arcSync)*.07;
		arcSync=System.currentTimeMillis();
		myGraphics.setColor(Color.darkGray);
		myGraphics.fillArc(x-14,y-14,30,30,(int)arcAng+  0,40);
		myGraphics.fillArc(x-14,y-14,30,30,(int)arcAng+120,40);
		myGraphics.fillArc(x-14,y-14,30,30,(int)arcAng+240,40);
		myGraphics.setColor(Color.yellow);
		myGraphics.fillArc(x-15,y-15,30,30,(int)arcAng+  0,40);
		myGraphics.fillArc(x-15,y-15,30,30,(int)arcAng+120,40);
		myGraphics.fillArc(x-15,y-15,30,30,(int)arcAng+240,40);		
	}
	
	//partial implementation of MouseListener,MouseMotionListener
	public void mouseEntered(MouseEvent myMouseEvent) {
		isMouseOver=true;
	}
	
	public void mouseExited(MouseEvent myMouseEvent) {
		isMouseOver=false;		
	}
	
	public void mouseMoved(MouseEvent myMouseEvent) {
	  mouse.pix=myMouseEvent.getX();
	  mouse.piy=myMouseEvent.getY();		
	}
	//strip-------------------------------------------	
	Mark lineStrip[];
	int count;
	Color lColor,tColor,bColor;
	void EnhancedLineStrip(Color lColor_in,Color tColor_in,Color bColor_in) {		
		lineStrip=new Mark[1000];
		count=0;
		lColor=lColor_in;
		tColor=tColor_in;
		bColor=bColor_in;
	}	
	void EnhancedLineStrip(int pix,int piy,int idx,boolean label,String str) {
		lineStrip[count]=new Mark();
			lineStrip[count].pix=pix;
			lineStrip[count].piy=piy;
			lineStrip[count].idx=idx;
			lineStrip[count].label=label;
			lineStrip[count].str=str;
		count++;
	}	
	void EnhancedLineStrip(Graphics myGraphics) {
		int c1;		
		myGraphics.setColor(bColor);
		for (c1=0;c1<count;c1++)
			if (lineStrip[c1].label)
				EnhancedMark(myGraphics,lineStrip[c1].pix,lineStrip[c1].piy);		
    myGraphics.setColor(bColor);
    for (c1=0;c1<count-1;c1++) {
	    myGraphics.drawLine(lineStrip[c1].pix+1,lineStrip[c1].piy  ,lineStrip[c1+1].pix+1,lineStrip[c1+1].piy  );
	    myGraphics.drawLine(lineStrip[c1].pix  ,lineStrip[c1].piy+1,lineStrip[c1+1].pix  ,lineStrip[c1+1].piy+1);
   	}
    myGraphics.setColor(tColor);
    for (c1=0;c1<count-1;c1++) {
	    myGraphics.drawLine(lineStrip[c1].pix-1,lineStrip[c1].piy  ,lineStrip[c1+1].pix-1,lineStrip[c1+1].piy  );
	    myGraphics.drawLine(lineStrip[c1].pix  ,lineStrip[c1].piy-1,lineStrip[c1+1].pix  ,lineStrip[c1+1].piy-1);
   	}
    myGraphics.setColor(lColor);
    for (c1=0;c1<count-1;c1++)
 	    myGraphics.drawLine(lineStrip[c1].pix  ,lineStrip[c1].piy  ,lineStrip[c1+1].pix  ,lineStrip[c1+1].piy  );
 	  
 	  int elev;
 		for (c1=0;c1<count;c1++)
			if (lineStrip[c1].label) {				
				if (c1<count-1) {
					if (lineStrip[c1+1].piy-lineStrip[c1].piy>0)
						elev=-5;
					else
						elev=15;
					}
				else
					elev=5;				
				EnhancedString(myGraphics,lineStrip[c1].str,lineStrip[c1].pix+10,Math.max(lineStrip[c1].piy+elev,10));
			}
	}

	
}
