// GpsMonitor
// code by jph

import java.lang.Math;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

class Locat
implements Comparator
{
  long   time;
  double gpsx;
  double gpsy;
  
  Locat() {}
  
  Locat(long time) {
    this.time=time;
  }
  
  Locat(long time,double gpsx,double gpsy) {
    this.time=time;
    this.gpsx=gpsx;
    this.gpsy=gpsy;
  }
  
  public int compare(Object myObject0,Object myObject1) {    
    long myLong=((Locat)myObject0).time-((Locat)myObject1).time;
    if (myLong< 0) return -1;
    if (myLong==0) return  0;
    return  1;
  }
}

class GpsMonitor
extends Monitor
implements MouseListener,MouseMotionListener
{
  static final String[] MAPS={"earth","jmuwc","peter","galge"};
  static final int EARTH=0;
	static final int JMUWC=1;
	static final int PETER=2;	
	
	boolean isDirty;
	int map;
	Pixel offset;
	volatile TreeSet myTreeSet;
	Image myImage;
	String label;
	
	volatile boolean myBoolean;
	int countToClean;
	
	double px,py;	
	double vx,vy;	

	GpsMonitor() {
  	super("GPS");
  	int c1;
		myTreeSet=new TreeSet(new Locat());
		isDirty=true;
		offset=new Pixel();
		label="";		
		map=-1;		
		myBoolean=false;
		countToClean=0;		
	}
	
	void add(long time,double gpsx,double gpsy) {
  	while (myBoolean) ;
  	myTreeSet.add(new Locat(time,gpsx,gpsy));
  	countToClean++;
	}
  
	public void paintMonitor(Graphics myGraphics) {
	  int c1;
	  double tx=0;
	  double ty=0;
	  Locat[] myLocat;
	  SortedSet mySortedSet;
	  myBoolean=true;
	  if (countToClean>20) {
	    countToClean=0;      
      mySortedSet=myTreeSet.subSet(new Locat(0),new Locat(time-20000));      
      myLocat=new Locat[mySortedSet.size()];
      mySortedSet.toArray(myLocat);
      for (c1=0;c1<mySortedSet.size();c1++)
        myTreeSet.remove(myLocat[c1]);
    }	  
 	  mySortedSet=myTreeSet.subSet(new Locat(time-15000),new Locat(time));
 	  myBoolean=false; 	  
	  myLocat=new Locat[mySortedSet.size()];
    mySortedSet.toArray(myLocat);  	
  	if (myLocat.length>0) {
		  tx=myLocat[myLocat.length-1].gpsx;
		  ty=myLocat[myLocat.length-1].gpsy;
	  }
	  int myInt=EARTH;
	  if (myLocat.length>0) {
	  	if ( 9.584<tx&&tx< 9.585&&
	  	    49.468<ty&&ty<49.469)
				myInt=JMUWC;
	  	if ( 9.576<tx&&tx< 9.577&&
	  	    49.465<ty&&ty<49.466)
				myInt=PETER;
		}
  	if (map!=myInt) {
    	isDirty=true;
	    switch (map=myInt) {
 				case EARTH: offset.set(-300,-100); break;
		    case JMUWC: offset.set(-640,-400); break;
				case PETER: offset.set(-450,-150); break;
			}
		}
    if (isDirty&&myLocat.length>0) {
      myImage=getToolkit().getImage("res/"+MAPS[map]+".jpg");
	    center(px=tx,py=ty);
			vx=vy=0;
	    isDirty=false;
    }
    if (myLocat.length>0) {
			double kap=4.8387,tau=0.82949;				
			double dt=.25;
			double ax=-kap*(tau*vx+px-tx);
			double ay=-kap*(tau*vy+py-ty);
			vx+=ax*dt; px+=vx*dt;
			vy+=ay*dt; py+=vy*dt;
			center(px,py);
  	}
  	MediaTracker myMediaTracker=new MediaTracker(this); 	
    myMediaTracker.addImage(myImage,map);
    try {
      myMediaTracker.waitForAll();
      myGraphics.drawImage(myImage,offset.pix,offset.piy,this);
    } catch (InterruptedException myInterruptedException) {}
    
		EnhancedLineStrip(Color.green);
    for (c1=0;c1<myLocat.length;c1++)
    	EnhancedLineStrip(Xpixel(myLocat[c1].gpsx)+offset.pix,Ypixel(myLocat[c1].gpsy)+offset.piy);
		EnhancedLineStrip(myGraphics);	
		if (myLocat.length>0) {
			EnhancedArcedCircle(myGraphics,Xpixel(tx)+offset.pix,Ypixel(ty)+offset.piy);
			EnhancedString(myGraphics,label,Xpixel(tx)+offset.pix+3,Ypixel(ty)+offset.piy+13);
		}
  }

  // returns pixel on bmp
	public int Xpixel(double gpsx) {
		double ax=1,rx=0;
		int bx=0;
		switch (map) {
  		case EARTH: ax=11.377778; rx=0;     bx=384; break;
  		case JMUWC: ax=620000; rx=9.584694; bx=737; break;
		  case PETER: ax=620000; rx=9.576475; bx=629; break;
	  }
		return (int)(ax*(gpsx-rx))+bx;
	}
	
	public int Ypixel(double gpsy) {
		double ay=-1,ry=0;
		int by=0;
		switch (map) {
  		case EARTH: ay=-11.377778; ry=0;      by=967; break;
  		case JMUWC: ay=-957447; ry=49.468525; by=780; break;
		  case PETER: ay=-957447; ry=49.465580; by=249; break;
	  }
		return (int)(ay*(gpsy-ry))+by;
	}
	
	void center(double gpsx,double gpsy) {
		offset.pix=getSize().width /2-Xpixel(gpsx);
		offset.piy=getSize().height/2-Ypixel(gpsy);
	}
	
  public void mousePressed(MouseEvent myMouseEvent) {
		//click.pix=myMouseEvent.getX();
		//click.piy=myMouseEvent.getY();	  
	}
	public void mouseReleased(MouseEvent myMouseEvent) {
		//if (myMouseEvent.getClickCount()==2) {
		//	myCansat7.myJComboBox[myCansat7.TRACK].setSelectedIndex(0);			
		//	repaint();
		//}
	}
	public void mouseClicked(MouseEvent myMouseEvent) {};
	
	public void mouseDragged(MouseEvent myMouseEvent) {		
		//myCansat7.myJComboBox[myCansat7.TRACK].setSelectedIndex(2);
		//offset.pix+=(int)(myMouseEvent.getX()-click.pix);
		//offset.piy+=(int)(myMouseEvent.getY()-click.piy);		
		//click.pix=myMouseEvent.getX();
		//click.piy=myMouseEvent.getY();				
		//dirtyFoc=false;
		//repaint();
	}
}



