// RT433F4
// code by jph

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class RT433F4
extends Remote
implements ActionListener
{
	static final Random myRandom=new Random(System.currentTimeMillis());
	static final String[] _HERTZ={"433.19","433.34","433.50","433.65","433.80","433.96","434.11","434.27","434.42","434.57"};
	static final String[] _POWER={"-8","-2","4","10"};
		
	JComboBox myJComboBox_HERTZ;
	JComboBox myJComboBox_POWER;
	JButton myJButton_SET;
	JButton myJButton_GET;
	JProgressBar myJProgressBar;
	
	RT433F4(Terminal myTerminal) {
		int c1;
		String myString;
		this.myTerminal=myTerminal;
		
		JPanel myJPanel=new JPanel();
		myJComboBox_HERTZ=new JComboBox(_HERTZ);
		myJComboBox_HERTZ.setToolTipText("select frequency of transceiver");
		myJComboBox_HERTZ.setSelectedIndex(6);
		myJPanel.add(myJComboBox_HERTZ);
		myJPanel.add(new JLabel("MHz "));
		myJComboBox_POWER=new JComboBox(_POWER);
		myJComboBox_POWER.setToolTipText("choose gain of transmission");
		myJComboBox_POWER.setSelectedIndex(3);
		myJPanel.add(myJComboBox_POWER);
		myJPanel.add(new JLabel("mdB "));
		myJButton_SET=new JButton("set");
		myJButton_SET.addActionListener(this);
		myJPanel.add(myJButton_SET);
		myJButton_GET=new JButton("get");
		myJButton_GET.addActionListener(this);
		myJPanel.add(myJButton_GET);		
		myJProgressBar=new JProgressBar(JProgressBar.HORIZONTAL,0,9);
		myJProgressBar.setStringPainted(true);
		myJProgressBar.setValue(0);
		myJPanel.add(myJProgressBar);
		myTerminal.myContainer.add("Center",myJPanel);
	  myTerminal.myJFrame.setSize(myTerminal.WIDTH,150);
	  myTerminal.myJFrame.validate();
		
	  myThread=new Thread(this);
	  myThread.start();
	}
	
	public void actionPerformed(ActionEvent myActionEvent) {
		int c1;		
		if (myJButton_SET==myActionEvent.getSource()) 
			set();
		if (myJButton_GET==myActionEvent.getSource()) 
			get();
	}

	public void run() {
		int c1,c2,c3=0;
		int cnt=0;
		int[] myByte;
		String gps;
		String myString;				
		myTerminal.debug=3;
		while (myTerminal.isLaunched) {
			try {
				myThread.sleep(50);
			} catch (InterruptedException myInterruptedException) {
				System.out.println(myInterruptedException);
			}
		}
  }  
	
	void set() {		
		int[] myByte;
		try {			
			myTerminal.print("+++");			
			myThread.sleep(250);
			myTerminal.clear();
			myTerminal.println("ATS2="+myJComboBox_HERTZ.getSelectedIndex());
			myThread.sleep(250);
			myTerminal.println("ATS3="+myJComboBox_POWER.getSelectedIndex());
			myThread.sleep(250);
			myTerminal.println("ATWR"); // write to EEPROM
			myThread.sleep(250);
			myTerminal.println("ATCC");
			myThread.sleep(250);
			myByte=myTerminal.read();
			myTerminal.clear();
			System.out.println(myTerminal.format(myByte));			
		} catch (InterruptedException myInterruptedException) {
			System.out.println(myInterruptedException);
		}
	}
		
	void get() {
		int[] myByte;
		String myString;		
		try {
			myTerminal.print("+++");			
			myThread.sleep(250);			
			myTerminal.clear();
			myTerminal.println("ATS2"); // 6
			myThread.sleep(250);
			myTerminal.println("ATS3");
			myThread.sleep(250);
			myTerminal.println("ATS15");
			myThread.sleep(250);
			myTerminal.println("ATS16");
			myThread.sleep(250);
			myTerminal.println("ATCC");
			myThread.sleep(250);
			myByte=myTerminal.read();									
			myString=myTerminal.format(myByte);
			System.out.println("["+myString+"]");			
			if (myString.length()>13) {				
				//myJComboBox_HERTZ.setSelectedIndex(Integer.parseInt(""+myString.charAt(4)));				
				//myJComboBox_POWER.setSelectedIndex(Integer.parseInt(""+myString.charAt(7)));
				//System.out.println("ware: "+myString.charAt(10));
				//myJProgressBar.setValue(Integer.parseInt(""+myString.charAt(13)));				
			} else {				
			}
		} catch (InterruptedException myInterruptedException) {
			System.out.println(myInterruptedException);
		}
	}	 
}

